jQuery(document).ready(function($){

/***********************************************
	[functions]
***********************************************/
		/****do  getid search  ***/
		ilwIdSearch = function(vars){
			/**hide results div**/
			$('#ilw-search-results-'+vars.wKey+'').fadeIn().html('<h3>searching...</h3>');

			jQuery.post(vars.url, {action :'ilw_itunes_json',vars:vars}, function(response) {

				data=response.iTunes;
				/**make all returned artists into an object**/
				var artistObj={};
				for(i in data.results){
					var artist = data.results[i];
					if(artist.artistId != undefined && artist.artistId != null){
						/**make it unique as we really do not need the same artisid more than once**/
						artistObj[''+artist.artistId+''] = {'artistName':''+artist.artistName+''};
					}
				}

				if(jQuery.isEmptyObject(artistObj)){
					/**if no artists found , show info**/
					$('#ilw-search-results-'+vars.wKey+'').html('<h3>Nothing Found !</h3>').fadeIn();
				}else{
					/**if artists found , show list upto maximum selected **/
//					c=0;
					var res='<h3>Your Search Results!</h3><span><small>check an option below and click "use selected"</small></span><div id="ilw-search-check-'+vars.wKey+'" class="ilw-search-check">';
					for(i in artistObj){
						/**set type to chackbox if we want to allow multiple selections**/
						res+='<label><input type="radio" name="ilw-search-artist-id" value="'+i+'">'+artistObj[i]['artistName']+'</label>';
//						c++;
//						if(c==vars.request.limit){
//						break;
//						}
					}
					res+='</div>';
					res+='<span>';
						res+='<input type="button" id="ilw-use-selected-'+vars.wKey+'" class="ilw-use-selected button-primary" value="use selected">';
					//*if we want to allow multiple selections in the future
					//	if(parameters.display.previousids.length>0){
					//	res+='<input type="button" id="ilw-add-selected-'+parameters.display.id+'" class="ilw-add-selected" value="add to previous">';
					//	}
					res+='</span>';

					$('#ilw-search-results-'+vars.wKey+'').html(res);
				}
			},'json')
			.error(function(jqXHR, textStatus, errorThrown) {
				alert("error : " + textStatus);
			});
		}

/***********************************************
	[events]
***********************************************/
		/**** show getid search  ***/
        $(document).on('click', '.ilw-id-search', function(e){
            e.preventDefault();
            var widgetid=((e.target.id).split("-")).pop(-1);
            $('#itunes-lookup-widget-option-'+widgetid+'').slideUp();
            $('#itunes-lookup-widget-idsearch-'+widgetid+'').slideDown();
            /**hide save/delete close**/
            $(this).closest('form').find('.widget-control-actions').hide();
        })
		/**** hide getid search  ***/
        $(document).on('click', '.ilw-do-reset', function(e){
            e.preventDefault();
            var widgetid=((e.target.id).split("-")).pop(-1);
            $('#itunes-lookup-widget-idsearch-'+widgetid+'').slideUp();
            $('#itunes-lookup-widget-option-'+widgetid+'').slideDown();

            /**show save/delete close**/
            $(this).closest('form').find('.widget-control-actions').show();
        })

        /**** pass parameters to getid search and do the ajax search***/
         $(document).on('click', '.ilw-do-search', function(e){
            e.preventDefault();
            
            /**get widget id**/
            var self=jQuery(this);
            var instanceId=self.closest('.itunes-lookup-widget').attr('id');
			/**get widget key**/
			var instanceKey=ilwParam['instances'][''+instanceId+''];
			
			/**select this widget key and add to localized parameters**/
			ilwParam.wKey=instanceKey;

			/**add itunes search request type to localized parameters**/
			ilwParam.type='search';
			
            /**add itunes request get variables to localized parameters**/
            ilwParam.request={};
			ilwParam.request.media='all';
			ilwParam.request.entity='allArtist';
			ilwParam.request.attribute='allArtistTerm';
			ilwParam.request.term=$('#ilw-search-term-'+instanceKey+'').val();
			ilwParam.request.limit=$('#ilw-max-results-'+instanceKey+'').val();

            /**now search for artis id's via ajax**/
            if(ilwParam.request.term!=''){
            	ilwIdSearch(ilwParam);
            }
        })

        /**** get selected artist ids of search , replacing or adding to old ones ->add currently not in use***/
         $(document).on('click', '.ilw-use-selected, .ilw-add-selected', function(e){
       	 	e.preventDefault();
       	 	var widgetid=((e.target.id).split("-")).pop(-1);

			var sel = new Array();
			/*add to previous values not implemented yet*/
			if($(this).attr('class')=='ilw-add-selected'){
				sel=$('#widget-itunes_lookup_widget-'+widgetid+'-artist_id').val().split(",");
			}

			$('#ilw-search-check-'+widgetid+' input:checked').each(function() {
			    sel.push($(this).val());
			});

			/*insert values*/
			$('#widget-itunes_lookup_widget-'+widgetid+'-artist_id').val(sel);
			/**hide search div / go back**/
			$('#itunes-lookup-widget-idsearch-'+widgetid+' .ilw-do-reset').trigger('click');
       	 })
		/*** toggle admin options settings screen divs ***/
		$(document).on('click', '.ilw-settings>.nav-tab-wrapper>a', function(e){
			var tabId=(this.className).split(" ").pop(-1);	
			/**hide all  other tabs**/
			$('.ilw-settings .ilw-settings-tab').hide();
			/**show selected tab**/
			$('#'+tabId+'').show();
		})
})